VERSION 2.00
Begin Form Weight 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Info on: "
   ClientHeight    =   4455
   ClientLeft      =   2565
   ClientTop       =   1170
   ClientWidth     =   3135
   FontBold        =   -1  'True
   FontItalic      =   0   'False
   FontName        =   "Times New Roman"
   FontSize        =   12
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   4890
   Icon            =   RECOG_WT.FRX:0000
   Left            =   2490
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   3135
   Top             =   810
   Width           =   3285
   Begin TextBox Text 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
   Begin PictureBox Grid 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      FillStyle       =   0  'Solid
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.5
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   3855
      Left            =   120
      ScaleHeight     =   257
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   193
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   480
      Width           =   2895
   End
   Begin CommandButton Button_close 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Default         =   -1  'True
      Height          =   255
      Left            =   2160
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
   Begin CommandButton Button_rename 
      Caption         =   "&Rename"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin Label Label 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   255
      Left            =   1080
      TabIndex        =   2
      Top             =   0
      Visible         =   0   'False
      Width           =   1095
   End
End
Const COLOUR_BLACK = &H0
Const COLOUR_WHITE = &HFFFFFF
Const COLOUR_RED = &HFF

' Close this window.
'
Sub Button_close_Click ()
  Unload Me
End Sub

' Prompt for a new name, then rename the character.
'
Sub Button_rename_Click ()
  oldLetter$ = Label
  letter$ = Trim$(Text.Text)
  If letter$ = "" Then
    Text.Text = oldLetter$
  Else
    If letter$ <> oldLetter$ Then
      If ListPosition(Letters(), letter$) Then
        MsgBox "That name is already in use.", 48, "Invalid name."
        Exit Sub ' Don't shift the focus.
      Else
        RenameChar oldLetter$, letter$
      End If
    End If
  End If
  Button_Rename.Default = False
  Button_Close.Default = True
  Button_Close.SetFocus ' Anticipate the focus.
End Sub

' Removes itself from the list of info windows.
'
Sub Form_Unload (Cancel As Integer)
  For index% = 1 To Wt_frms%
    If WT_frm(index%).Label.Caption = Me.Label.Caption Then
      victim% = index%
    End If
  Next index%
  If victim% = 0 Then Stop ' [Can't happen]
  Set WT_frm(victim%) = WT_frm(Wt_frms%)
  Wt_frms% = Wt_frms% - 1
  ReDim Preserve WT_frm(Wt_frms%)
End Sub

' Changing this hidden label forces the window to update itself.
'
Sub Label_Change ()
  If Me.Label.Caption = "" Then Exit Sub
  
  ' Update the title.
  Me.Caption = RTrim("Info on: " + Me.Label.Caption)
  Me.Text.Text = Me.Label.Caption

  ' Update the grid.
  offset% = ListPosition(Letters(), (Me.Label.Caption))
  If offset% = 0 Then Stop ' [Can't happen]
  offset% = offset% * GridX% * GridY% - (GridX% * GridY% - 1)
  max% = 1
  For z% = 0 To (GridX% * GridY% - 1)
    datum% = Abs(Val(Grids(offset% + z%)))
    If max% < datum% Then max% = datum%
  Next z%
  
  newY% = 0
  For y% = 0 To GridY% - 1
    oldY% = newY%
    newY% = (y% + 1) / GridY% * (Me.Grid.ScaleHeight - 1)
    newX% = 0
    For x% = 0 To GridX% - 1
      oldX% = newX%
      newX% = (x% + 1) / GridX% * (Me.Grid.ScaleWidth - 1)
      number% = Val(Grids(offset% + (y% * GridX%) + x%))
      shade& = (-number% + max%) / (max% * 2) * &HFF
      Me.Grid.FillColor = shade& * &H10000 + shade& * &H100 + shade&
      Me.Grid.Line (oldX%, oldY%)-(newX%, newY%), COLOUR_BLACK, B
      Me.Grid.CurrentX = oldX% + 5
      Me.Grid.CurrentY = oldY% + 5
      Me.Grid.ForeColor = COLOUR_RED
      Me.Grid.Print number%
    Next x%
  Next y%

  newY% = 0
  For y% = 0 To GridY% - 1
    oldY% = newY%
    newY% = (y% + 1) / GridY% * (Me.Grid.ScaleHeight - 1)
    newX% = 0
    For x% = 0 To GridX% - 1
      oldX% = newX%
      newX% = (x% + 1) / GridX% * (Me.Grid.ScaleWidth - 1)
      Me.Grid.PSet (oldX%, oldY%), COLOUR_WHITE
      Me.Grid.PSet (newX%, oldY%), COLOUR_WHITE
      Me.Grid.PSet (oldX%, newY%), COLOUR_WHITE
      Me.Grid.PSet (newX%, newY%), COLOUR_WHITE
    Next x%
  Next y%
End Sub

' Rename a character and update
' Letters(), Letter_list, and any info window.
' [This sub could be moved to any module - as long as there is a mechanism for this info window to call it.]
'
Sub RenameChar (oldName$, newName$)
  index% = ListPosition(Letters(), oldName$)
  If index% = 0 Then Stop ' [Can't happen]
  Letters(index%) = newName$
  For index% = 0 To Recog.Letter_list.ListCount - 1
    item$ = Recog.Letter_list.List(index%)
    If item$ = oldName$ Or InStr(item$, oldName$ + Chr$(9)) = 1 Then
      Recog.Letter_list.List(index%) = newName$ + Right$(item$, Len(item$) - Len(oldName$))
      Exit For
    End If
  Next index%
  
  ' Is there an info window open for the letter$?
  For index% = 1 To Wt_frms%
    If WT_frm(index%).Label.Caption = oldName$ Then WT_frm(index%).Label.Caption = "": WT_frm(index%).Label.Caption = newName$
  Next index%
  
  Recog.Menu_chrs_save.Enabled = True
  Recog.Menu_chrs_saveAs.Enabled = True
End Sub

' Switch the focus to the rename button if the name is edited.
'
Sub Text_Change ()
  Button_Rename.Default = True
  Button_Close.Default = False
End Sub

